import pytest
from lhcsmapi.metadata import signal_metadata
from nxcals.spark_session_builder import get_or_create

from lhcsmpowering import analyses

from . import common


@pytest.mark.parametrize(
    ("hwc_test", "circuit_name", "campaign", "t_start", "t_end", "expected_logs"),
    [
        (
            # 60a
            "PNO.a1",
            "RCBH11.L2B1",
            "Recommissioning 2022/2023",
            "2023-03-15 14:29:52.834000000",
            "2023-03-15 14:51:42.175000000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLA.12L2.RCBH11.L2B1, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 36.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00009 A, which is within the threshold of 0.01100 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00011 A, which is within the threshold of 0.01100 A. Expected plateau level: 55.00000 A.",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00012 A, which is within the threshold of 0.01100 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is -0.002095 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is 0.04154 V, which is within the allowed range from 0.02500 to 0.07500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is -0.002089 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is -0.001556 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is 0.03913 V, which is within the allowed range from 0.02500 to 0.07500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is -0.001554 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLA.12L2.RCBH11.L2B1 is 0.00309 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLA.12L2.RCBH11.L2B1 is 0.00284 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is 0.000793 Ohm, which is within the allowed range from 0.000450 to 0.001350 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is 0.000740 Ohm, which is within the allowed range from 0.000450 to 0.001350 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is 0.000000176 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001800 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is 0.000000169 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001800 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLA.12L2.RCBH11.L2B1 is 5.709 H, which is within the allowed range from 5.500 to 6.500 H.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLA.12L2.RCBH11.L2B1 is 0.000232 Ohm, which is within the allowed range from -0.000500 to 0.005000 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00010 A, which is within the threshold of 0.01100 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00090 A, which is within the threshold of 0.01100 A. Expected plateau level: -55.00000 A.",
                "\tCheck passed: The plateau duration for RPLA.12L2.RCBH11.L2B1 RPLA.12L2.RCBH11.L2B1:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLA.12L2.RCBH11.L2B1 ILEADS.I_MEAS signal is 0.00032 A, which is within the threshold of 0.01100 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is -0.002092 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is -0.04657 V, which is within the allowed range from -0.07500 to -0.02500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is -0.002095 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is -0.001555 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is -0.04313 V, which is within the allowed range from -0.07500 to -0.02500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is -0.001556 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLA.12L2.RCBH11.L2B1 is 0.00296 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLA.12L2.RCBH11.L2B1 is 0.00270 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is 0.000809 Ohm, which is within the allowed range from 0.000450 to 0.001350 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is 0.000756 Ohm, which is within the allowed range from 0.000450 to 0.001350 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLA.12L2.RCBH11.L2B1 is 0.000000167 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001800 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLA.12L2.RCBH11.L2B1 is 0.000000166 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001800 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLA.12L2.RCBH11.L2B1 is 5.712 H, which is within the allowed range from 5.500 to 6.500 H.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLA.12L2.RCBH11.L2B1 is 0.000355 Ohm, which is within the allowed range from -0.000500 to 0.005000 Ohm.",
            ],
        ),
        (
            # RCB RPLB 80A
            "PNO.a1",
            "RCBCV5.L8B2",
            "Commissioning post ITL8",
            "2023-08-24 17:31:52.884000000",
            "2023-08-24 17:55:55.723000000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLB.UA83.RCBCV5.L8B2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00035 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00033 A, which is within the threshold of 0.01600 A. Expected plateau level: 80.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00029 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is -0.000246 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is 0.02263 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is -0.000246 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000854 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.02327 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000854 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCBCV5.L8B2 is 0.00944 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCBCV5.L8B2 is 0.00874 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is 0.0002860 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.0002802 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is 0.000000011 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000000009 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLB.UA83.RCBCV5.L8B2 is 2.724 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA83.RCBCV5.L8B2 is 0.000222 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00035 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00030 A, which is within the threshold of 0.01600 A. Expected plateau level: -80.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCBCV5.L8B2 RPLB.UA83.RCBCV5.L8B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCBCV5.L8B2 ILEADS.I_MEAS signal is 0.00024 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is -0.000245 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is -0.02306 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is -0.000246 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000853 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is -0.02170 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000854 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCBCV5.L8B2 is 0.00776 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCBCV5.L8B2 is 0.00075 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is 0.0002852 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.0002819 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA83.RCBCV5.L8B2 is 0.000000009 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA83.RCBCV5.L8B2 is 0.000000007 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLB.UA83.RCBCV5.L8B2 is 2.726 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA83.RCBCV5.L8B2 is 0.000399 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
            ],
        ),
        (
            # RCB RPLB 120A
            "PNO.a1",
            "RCBCH8.L8B2",
            "Recommissioning post LS2",
            "2021-02-02 07:41:42.461000",
            "2021-02-02 08:04:08.114000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLB.UJ83.RCBCH8.L8B2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00020 A, which is within the threshold of 0.02000 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00030 A, which is within the threshold of 0.02000 A. Expected plateau level: 100.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00041 A, which is within the threshold of 0.02000 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is -0.000002 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is 0.03145 V, which is within the allowed range from 0.02500 to 0.06500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is -0.000000 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is -0.000608 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is 0.03432 V, which is within the allowed range from 0.02500 to 0.06500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is -0.000599 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UJ83.RCBCH8.L8B2 is -0.00162 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UJ83.RCBCH8.L8B2 is -0.00232 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is 0.0003145 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is 0.0003492 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is 0.000000043 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is 0.000000043 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLB.UJ83.RCBCH8.L8B2 is 2.715 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UJ83.RCBCH8.L8B2 is 0.000292 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00025 A, which is within the threshold of 0.02000 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 302.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00028 A, which is within the threshold of 0.02000 A. Expected plateau level: -100.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UJ83.RCBCH8.L8B2 RPLB.UJ83.RCBCH8.L8B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UJ83.RCBCH8.L8B2 ILEADS.I_MEAS signal is 0.00050 A, which is within the threshold of 0.02000 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is -0.000001 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is -0.03233 V, which is within the allowed range from -0.06500 to -0.02500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is -0.000001 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is -0.000601 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is -0.03623 V, which is within the allowed range from -0.06500 to -0.02500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is -0.000591 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UJ83.RCBCH8.L8B2 is -0.00297 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UJ83.RCBCH8.L8B2 is -0.00338 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is 0.0003233 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is 0.0003563 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UJ83.RCBCH8.L8B2 is 0.000000031 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UJ83.RCBCH8.L8B2 is 0.000000032 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLB.UJ83.RCBCH8.L8B2 is 2.715 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UJ83.RCBCH8.L8B2 is 0.000400 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
            ],
        ),
        (
            # RCB RPMC 80A
            "PNO.a1",
            "RCBCH6.R3B2",
            "Recommissioning post LS2",
            "2021-03-02 19:02:23.598000000",
            "2021-03-02 19:26:15.682000000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPMC.UJ33.RCBCH6.R3B2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 32.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00161 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00073 A, which is within the threshold of 0.01600 A. Expected plateau level: 80.00000 A.",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00149 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000754 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.02813 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000747 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000743 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.02772 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000753 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPMC.UJ33.RCBCH6.R3B2 is 0.0931 V, which is within the allowed range from -0.1500 to 0.1500 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPMC.UJ33.RCBCH6.R3B2 is 0.0934 V, which is within the allowed range from -0.1500 to 0.1500 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.0003423 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.0003372 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000000026 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000000023 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPMC.UJ33.RCBCH6.R3B2 is 2.659 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPMC.UJ33.RCBCH6.R3B2 is -0.000136 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00175 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00067 A, which is within the threshold of 0.01600 A. Expected plateau level: -80.00000 A.",
                "\tCheck passed: The plateau duration for RPMC.UJ33.RCBCH6.R3B2 RPMC.UJ33.RCBCH6.R3B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMC.UJ33.RCBCH6.R3B2 ILEADS.I_MEAS signal is 0.00163 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000757 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is -0.02708 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000750 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000744 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is -0.02668 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000751 V, which is within the allowed range from -0.007000 to 0.007000 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPMC.UJ33.RCBCH6.R3B2 is 0.0934 V, which is within the allowed range from -0.1500 to 0.1500 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPMC.UJ33.RCBCH6.R3B2 is 0.0887 V, which is within the allowed range from -0.1500 to 0.1500 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.0003479 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.0003428 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPMC.UJ33.RCBCH6.R3B2 is 0.000000019 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPMC.UJ33.RCBCH6.R3B2 is 0.000000017 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPMC.UJ33.RCBCH6.R3B2 is 2.668 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPMC.UJ33.RCBCH6.R3B2 is 0.000681 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
            ],
        ),
        (
            # RCB RPMC 120A
            "PNO.a1",
            "RCBCH6.R7B2",
            "Recommissioning post LS2",
            "2021-02-02 19:22:42.874000",
            "2021-02-02 19:45:41.127000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLBB.RR77.RCBCH6.R7B2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 48.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00016 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00036 A, which is within the threshold of 0.01600 A. Expected plateau level: 80.00000 A.",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00024 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000254 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.02727 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000243 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000246 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.02858 V, which is within the allowed range from 0.01500 to 0.04500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000244 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLBB.RR77.RCBCH6.R7B2 is 0.01234 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLBB.RR77.RCBCH6.R7B2 is 0.01223 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.0003378 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.0003541 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000000029 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000000032 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLBB.RR77.RCBCH6.R7B2 is 2.702 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLBB.RR77.RCBCH6.R7B2 is 0.001717 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 108.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00039 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00036 A, which is within the threshold of 0.01600 A. Expected plateau level: -80.00000 A.",
                "\tCheck passed: The plateau duration for RPLBB.RR77.RCBCH6.R7B2 RPLBB.RR77.RCBCH6.R7B2:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLBB.RR77.RCBCH6.R7B2 ILEADS.I_MEAS signal is 0.00038 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000243 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is -0.02735 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000243 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000244 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is -0.02864 V, which is within the allowed range from -0.04500 to -0.01500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000244 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLBB.RR77.RCBCH6.R7B2 is 0.01310 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLBB.RR77.RCBCH6.R7B2 is 0.01282 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.0003449 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.0003611 Ohm, which is within the allowed range from 0.0002000 to 0.0006000 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLBB.RR77.RCBCH6.R7B2 is 0.000000022 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLBB.RR77.RCBCH6.R7B2 is 0.000000025 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck passed: The average of L_MAG during ramp up and ramp down for RPLBB.RR77.RCBCH6.R7B2 is 2.711 H, which is within the allowed range from 2.556 to 3.124 H.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLBB.RR77.RCBCH6.R7B2 is 0.002182 Ohm, which is within the allowed range from -0.001000 to 0.003000 Ohm.",
            ],
        ),
        (
            # RPLB low current triplet
            "PNO.a1",
            "RCTX3.L8",
            "Recommissioning post LS2",
            "2021-10-05 13:14:10.799000000",
            "2021-10-05 13:40:51.756000000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLB.UA83.RCTX3.L8, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 32.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00151 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00176 A, which is within the threshold of 0.01600 A. Expected plateau level: 80.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00162 A, which is within the threshold of 0.01600 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is -0.000245 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is 0.0975 V, which is within the allowed range from 0.0550 to 0.1150 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is -0.000245 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000976 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.1008 V, which is within the allowed range from 0.0550 to 0.1150 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000977 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCTX3.L8 is 0.00571 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCTX3.L8 is 0.00630 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA83.RCTX3.L8 is 0.001222 Ohm, which is within the allowed range from 0.000687 to 0.001437 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.001248 Ohm, which is within the allowed range from 0.000687 to 0.001437 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA83.RCTX3.L8 is 0.000000125 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000000119 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck skipped.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA83.RCTX3.L8 is 0.001775 Ohm, which is within the allowed range from -0.001000 to 0.003500 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 32.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00205 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00152 A, which is within the threshold of 0.01600 A. Expected plateau level: -80.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA83.RCTX3.L8 RPLB.UA83.RCTX3.L8:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA83.RCTX3.L8 ILEADS.I_MEAS signal is 0.00190 A, which is within the threshold of 0.01600 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is -0.000246 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is -0.09741 V, which is within the allowed range from -0.11500 to -0.05500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA83.RCTX3.L8 is -0.000245 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000977 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is -0.09828 V, which is within the allowed range from -0.11500 to -0.05500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000976 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCTX3.L8 is 0.00688 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA83.RCTX3.L8 is 0.00680 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA83.RCTX3.L8 is 0.001215 Ohm, which is within the allowed range from 0.000687 to 0.001437 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.001241 Ohm, which is within the allowed range from 0.000687 to 0.001437 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA83.RCTX3.L8 is 0.000000119 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA83.RCTX3.L8 is 0.000000097 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck skipped.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA83.RCTX3.L8 is 0.002280 Ohm, which is within the allowed range from -0.001000 to 0.003500 Ohm.",
            ],
        ),
        (
            # RPLB high current triplet
            "PNO.a1",
            "RCOSX3.R8",
            "Recommissioning post LS2",
            "2021-04-24 16:15:18.688000000",
            "2021-04-24 16:44:16.184000000",
            [
                "PM buffers presence and timestamps check",
                "\tCheck passed: Found exactly 2 PM timestamps for FGC RPLB.UA87.RCOSX3.R8, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 32.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00186 A, which is within the threshold of 0.02000 A. Expected plateau level: 0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00240 A, which is within the threshold of 0.02000 A. Expected plateau level: 100.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00379 A, which is within the threshold of 0.02000 A. Expected plateau level: 0.00000 A.",
                "Current leads voltage check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is -0.000043 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is 0.1133 V, which is within the allowed range from 0.0900 to 0.1500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is -0.000129 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000493 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.1130 V, which is within the allowed range from 0.0900 to 0.1500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000489 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (positive cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA87.RCOSX3.R8 is 0.02549 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA87.RCOSX3.R8 is 0.02485 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (positive cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA87.RCOSX3.R8 is 0.001134 Ohm, which is within the allowed range from 0.000900 to 0.001500 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.001125 Ohm, which is within the allowed range from 0.000900 to 0.001500 Ohm.",
                "Current leads resistance slope check (positive cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA87.RCOSX3.R8 is 0.000000214 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000000203 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (positive cycle)",
                "\tCheck skipped.",
                "Magnet resistance check (positive cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA87.RCOSX3.R8 is 0.002065 Ohm, which is within the allowed range from -0.001000 to 0.003500 Ohm.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 30.00 s, which is greater than the minimum required duration of 30.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00259 A, which is within the threshold of 0.02000 A. Expected plateau level: -0.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 300.0 s, which is greater than the minimum required duration of 300.0 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00280 A, which is within the threshold of 0.02000 A. Expected plateau level: -100.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA87.RCOSX3.R8 RPLB.UA87.RCOSX3.R8:I_REF signal is 28.00 s, which is greater than the minimum required duration of 25.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA87.RCOSX3.R8 ILEADS.I_MEAS signal is 0.00239 A, which is within the threshold of 0.02000 A. Expected plateau level: -0.00000 A.",
                "Current leads voltage check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is -0.000136 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is -0.11301 V, which is within the allowed range from -0.15000 to -0.09000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_POS for RPLB.UA87.RCOSX3.R8 is -0.000131 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000489 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is -0.11182 V, which is within the allowed range from -0.15000 to -0.09000 V.",
                "\tCheck passed: The average value of ILEADS.U_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000489 V, which is within the allowed range from -0.003500 to 0.003500 V.",
                "PC voltage offset check (negative cycle)",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA87.RCOSX3.R8 is 0.02485 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "\tCheck passed: The average value of ILEADS.V_MEAS for RPLB.UA87.RCOSX3.R8 is 0.02467 V, which is within the allowed range from -0.05000 to 0.05000 V.",
                "Current leads resistance check (negative cycle)",
                "\tCheck passed: The average value of R_LEAD_POS for RPLB.UA87.RCOSX3.R8 is 0.001129 Ohm, which is within the allowed range from 0.000900 to 0.001500 Ohm.",
                "\tCheck passed: The average value of R_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.001123 Ohm, which is within the allowed range from 0.000900 to 0.001500 Ohm.",
                "Current leads resistance slope check (negative cycle)",
                "\tCheck passed: The average value of dR_LEAD_POS for RPLB.UA87.RCOSX3.R8 is 0.000000206 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "\tCheck passed: The average value of dR_LEAD_NEG for RPLB.UA87.RCOSX3.R8 is 0.000000199 Ohm/s, which is within the allowed range from 0.000000000 to 0.000001400 Ohm/s.",
                "Magnet inductance check (negative cycle)",
                "\tCheck skipped.",
                "Magnet resistance check (negative cycle)",
                "\tCheck passed: The average value of R_MAG for RPLB.UA87.RCOSX3.R8 is 0.002481 Ohm, which is within the allowed range from -0.001000 to 0.003500 Ohm.",
            ],
        ),
    ],
)
def test_pno_a1_analysis(
    hwc_test: str, circuit_name: str, campaign: str, t_start: str, t_end: str, expected_logs: list[str]
) -> None:
    # arrange
    test_parameters = analyses.get_analysis_test_input_parameters(
        signal_metadata.get_hwc_summary(), hwc_test, circuit_name, campaign, t_start, t_end
    )
    spark = get_or_create()

    # act
    analysis_class = analyses.PnoA1Analysis("", test_parameters)
    analysis_class.set_spark(spark)
    analysis_class.query()
    analysis_class.analyze()

    # assert
    assert analysis_class.get_analysis_output() is True
    assert common.get_log_strings(analysis_class) == expected_logs
